# API related exceptions


class BadRequest(ValueError):
    pass


class PPAServerError(ValueError):
    pass


# Event (SMTP, syslog) related exceptions


class EventConfigurationError(Exception):
    pass


class EventNotConfigured(Exception):
    def __init__(self, event):
        super(EventNotConfigured, self).__init__(
            f"Cannot send {event.event_name} as {event.protocol} is not configured in the PPA appliance."
        )


class EventTypeDisabled(Exception):
    def __init__(self, event):
        super(EventTypeDisabled, self).__init__(
            f"Cannot send {event.event_name} as {event.protocol} is disabled in the PPA appliance."
        )


class NoMailRecipients(Exception):
    def __init__(self):
        super(NoMailRecipients, self).__init__(
            "Cannot send email as no recipients were provided in the API call, "
            "and the PPA appliance SMTP configuration has no default recipient."
        )


# Appliance version exceptions


class RetiredFunction(Exception):
    pass


class PPAVersionError(Exception):
    pass


# Data exceptions


class ValueAlreadyExists(Exception):
    pass
